#ifndef EIGENMB_H
#define EIGENMB_H
#include <math.h>
#include <float.h>

#define RC_COMPLEX_EVAL 2	/* code that complex eigenvalue obtained */

int      InvertMatrix (double **a, int n, double *col, int *indx, double **a_inv);
int      LUDecompose (double **a, int n, double *vv, int *indx, double *pd);
int      EigenRealGeneral (int n, double **a, double *v, double *vi, double **u, int *iwork, double *work);
void     LUBackSubst (double **a, int n, int *indx, double *b);
int      EigenRG (int n, double **a, double *wr, double *wi, double **z, int *iv1, double *fv1);
void     Balanc (int n, double **a, int *pLow, int *pHigh, double *scale);
void     Exchange (int j, int k, int l, int m, int n, double **a, double *scale);
void     ElmHes (int n, int low, int high, double **a, int *intchg);
void     ElTran (int n, int low, int high, double **a, int *intchg, double **z);
int      Hqr2 (int n, int low, int high, double **h, double *wr, double *wi, double **z);
void     BalBak (int n, int low, int high, double *scale, int m, double **z);
void     CDiv (double ar, double ai, double br, double bi, double *cr, double *ci);
double   D_sign (double a, double b);


#define TINY		1.0e-20
#if !defined(MAX)
#	define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#endif
#if !defined(MIN)
#	define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#endif

#define FALSE					0
#define TRUE					1
#define NO_ERROR				0
#define ERROR					1

#endif
