#include "utilities.h"
#include "free.h"


void Free(void *p)
{
  //printf("FREEING\n");
  if (p) free(p);
}

/*********************************************************/

void Free_Seq(seq **d, int n_otu)
{
  int i;
  For(i,n_otu)
    {
      Free(d[i]->name);
      Free(d[i]->state);
      Free(d[i]);
    }
  Free(d);
}


/*********************************************************/
void Free_Tree_Lk(arbre *tree)
{
  int i;
  edge *b;
  node *n;
  //  printf("In Free_Tree_Lk1\n");
  b = NULL;
  n = NULL; //printf("In Free_Tree_Lk2\n");
  Free(tree->tot_loglk_sorted);
  Free(tree->tot_dloglk);
  Free(tree->tot_d2loglk); //printf("In Free_Tree_Lk3\n");
  Free(tree->tot_dloglk_domega_sorted);
  // Free(tree->tot_dloglk_domega);
  Free(tree->tot_d2loglk_domega2_sorted);
  // Free(tree->tot_d2loglk_domega2);

  Free(tree->tot_dloglk_dtheta_sorted);
  Free(tree->tot_d2loglk_dtheta2_sorted);
  Free(tree->tot_dloglk_dtot_sorted);
  Free(tree->tot_d2loglk_dtot2_sorted);
  Free(tree->tot_dloglk_dfrac_sorted);
  Free(tree->tot_d2loglk_dfrac2_sorted);
  Free(tree->t_best_l);
  Free(tree->site_lk);
  if(tree->p_lk) Free(tree->p_lk);
  // printf("In Free_Tree_Lk4\n");
  For(i,2*tree->n_otu-2)
    {
      b = tree->t_edges[i];
      
      Free_Edge_Lk(tree,b);

    }
  //printf("In Free_Tree_Lk5\n");
}


/*********************************************************/
void Free_Edge_Lk(arbre *tree, edge *b)
{
  int pos, i,j;
  // printf("In Free_Edge_Lk 1\n");
  Free(b->ql);
  //printf("In Free_Edge_Lk 2\n");
  if(b->p_lk_left)
    {
      For(pos, tree->mod->n_pos)
	{
	  For(i,tree->data->crunch_len)
	    {
	      For(j,tree->mod->n_catg)
		{
		  Free(b->p_lk_left[pos][i][j]);
		}
	      Free(b->p_lk_left[pos][i]);
	    }
	  Free(b->p_lk_left[pos]);
	}
      Free(b->p_lk_left);
      Free(b->sum_scale_f_left);
    }
  // printf("In Free_Edge_Lk 3\n");
  if(b->p_lk_rght)
    {
      For(pos, tree->mod->n_pos)
	{
	  For(i,tree->data->crunch_len)
	    {
	      For(j,tree->mod->n_catg)
		{
		  Free(b->p_lk_rght[pos][i][j]);
		}
	      Free(b->p_lk_rght[pos][i]);
	    }
	  Free(b->p_lk_rght[pos]);
	}
      Free(b->p_lk_rght);
      Free(b->sum_scale_f_rght);
    }
  // printf("In Free_Edge_Lk 4\n");

  For(pos, tree->mod->n_pos)
    {
      For(i,tree->mod->n_catg)
	{
	  For(j,tree->mod->ns)
	    {
	      Free(b->Pij_rr[pos][i][j]);
	      Free(b->dPij_rr[pos][i][j]);
	      Free(b->d2Pij_rr[pos][i][j]);
	      
	      Free(b->dPij_rr_theta[pos][i][j]);
	      Free(b->dPij_rr_frac[pos][i][j]);
	      Free(b->d2Pij_rr_frac[pos][i][j]);
	    }
	  
	  Free(b->Pij_rr[pos][i]);
	  Free(b->dPij_rr[pos][i]);
	  Free(b->d2Pij_rr[pos][i]);
	  
	  Free(b->dPij_rr_theta[pos][i]);
	  Free(b->dPij_rr_frac[pos][i]);
	  Free(b->d2Pij_rr_frac[pos][i]);
	  
	  /*   Free(b->site_p_lk_left[i]);
	       Free(b->site_p_lk_rght[i]);     */
	}
      Free(b->Pij_rr[pos]);
      Free(b->dPij_rr[pos]);
      Free(b->d2Pij_rr[pos]);
      
      Free(b->dPij_rr_theta[pos]);
      Free(b->dPij_rr_frac[pos]);
      Free(b->d2Pij_rr_frac[pos]);
    }
  //printf("In Free_Edge_Lk 5\n");
  Free(b->Pij_rr);
  Free(b->dPij_rr);
  Free(b->d2Pij_rr);

  Free(b->dPij_rr_theta);
  Free(b->dPij_rr_frac);
  Free(b->d2Pij_rr_frac);
  /*  Free(b->site_p_lk_left);
      Free(b->site_p_lk_rght);*/
  Free(b->site_dlk_rr);
  Free(b->site_d2lk_rr);
  // printf("In Free_Edge_Lk 6\n");
}

/*********************************************************/

void Free_Model(model *mod)
{



  Free(mod->pi);
  Free(mod->r_proba);
  Free(mod->rr);
  Free(mod->kappa);
  Free(mod->omega);
  Free(mod->kappa_old);
  Free(mod->omega_old);
  Free(mod->l_coef);
  Free(mod->ThetaValues);

  // Free(mod->rr_param);

  //  Free(mod->mat_Q);
  // Free(mod->mat_Vr);
  //Free(mod->mat_Vi);
  //Free(mod->vct_eDmr);
  //Free(mod->vct_ev);

  /*  For(i,mod->n_catg)
    {
      For(j,mod->ns) Free(mod->Pij_rr[i][j]);
      Free(mod->Pij_rr[i]);
    }
    Free(mod->Pij_rr);
  For(i,mod->n_catg)
    {
      For(j,mod->ns) Free(mod->dPij_rr[i][j]);
      Free(mod->dPij_rr[i]);
    }
  Free(mod->dPij_rr);
  For(i,mod->n_catg)
    {
      For(j,mod->ns) Free(mod->d2Pij_rr[i][j]);
      Free(mod->d2Pij_rr[i]);
    }
    Free(mod->d2Pij_rr);*/
  


  Free(mod);
}

/*********************************************************/
void Free_Cseq(allseq *data)
{
  int i;
  //  printf("Debut Cseq\n");
  //  Free(data->invar);
  Free(data->score_site);
  Free(data->wght);
  Free(data->factw);
  Free(data->ambigu);
  Free(data->b_frq);
  Free(data->c_frq);
  //  For(i,data->init_len) Free(data->pospatt[i]);
   Free(data->pospatt);
   ///printf("After 1 for\n");
  For(i,data->n_otu)
    {
      Free(data->c_seq[i]->name);
      Free(data->c_seq[i]->state);
      Free(data->c_seq[i]);
    }//printf("After for\n");
  Free(data->c_seq);
  Free(data);
}

/*********************************************************/
void Free_Tree(arbre *tree)
{
  int i;
  edge *b;
  node *n;

  
  For(i,2*tree->n_otu-2)
    {
      b = tree->t_edges[i];
      Free_Edge(b);
    }
  
     Free(tree->t_edges);
     
     
     For(i,2*tree->n_otu-1)
       {
	 n = tree->noeud[i];
	 Free_Node(n);
       }
     Free(tree->noeud);
     
     Free(tree);
}

/*********************************************************/
void Free_Edge(edge *b)
{
  Free(b);
}

/*********************************************************/

void Free_Node(node *n)
{
  Free(n->b);
  Free(n->v);
  Free(n->l);
  Free(n->score);
  Free(n->name);
  Free(n->n_ex_nodes);
  Free(n);
}

/*********************************************************/
void Free_Code(code *c_code)
{
  int i;

  Free(c_code->n_diff_b_2_codons);
  Free(c_code->tstvtable);
  Free(c_code->sense_c);
  Free(c_code->name);
  Free(c_code->from_64_2_61);
  Free(c_code->aa);
  Free(c_code->gg_98_codon);
  For(i,17)
    Free(c_code->genetc[i]);
  Free(c_code->genetc);

  Free(c_code);
}

/*********************************************************/
