/*

nhPhyml :  a program that builds phylogenetic trees from DNA alignments using the non-homogeneous, non-stationary model of evolution conceived by Galtier and Gouy (1998) and the algorithmic structure of phyml (Guindon and Gascuel, 2003).

Copyright (C) Bastien Boussau. jul. 2005 onward

All parts of  the source except where indicated  are distributed under
the GNU public licence.  See http://www.opensource.org for details.

*/

#ifndef FREE_H
#define FREE_H

void Free(void *p);
void Free_Seq(seq **d, int n_otu);
void Free_Tree_Lk(arbre *tree);
void Free_Edge_Lk(arbre *tree, edge *b);
void Free_Model(model *mod);
void Free_Cseq(allseq *data);
void Free_Tree(arbre *tree);
void Free_Edge(edge *b);
void Free_Node(node *n);
void Free_Code(code *c_code);
#endif
