/*

nhPhyml :  a program that builds phylogenetic trees from DNA alignments using the non-homogeneous, non-stationary model of evolution conceived by Galtier and Gouy (1998) and the algorithmic structure of phyml (Guindon and Gascuel, 2003).

Copyright (C) Bastien Boussau. jul. 2005 onward

All parts of  the source except where indicated  are distributed under
the GNU public licence.  See http://www.opensource.org for details.

*/


#ifndef ML_H
#define ML_H

void      Make_Tree_4_Lk(arbre *tree, allseq *alldata, int n_site);
void      Init_Tips_At_One_Site_Nucleotides(char state, double **p_lk);
double    Return_Lk(arbre *tree);
void      Lk(arbre *tree,allseq *alldata);
void      Post_Order_Lk(node *pere, node *fils, arbre *tree);
void      Pre_Order_Lk(node *pere, node *fils, arbre *tree);
void      Pre_Order_Lk_Scale(node *pere, node *fils, arbre *tree);
void      Get_All_Partial_Lk(arbre *tree, edge *b_fcus, node *a, node *d);
void      Get_All_Partial_Lk_Scale(arbre *tree, edge *b_fcus, node *a, node *d);
void      Computes_Root_Lk (node *root, arbre *tree);
void      Site_Lk(arbre *tree, allseq *alldata, int pos);
double    Lk_At_Given_Edge(arbre *tree, edge *b_fcus);
void      Update_P_Lk(arbre *tree, edge *b_fcus, node *n);
void      Unconstraint_Lk(arbre *tree);
void      Site_Lk_Simple (arbre *tree, allseq *alldata);
void      Lk_At_Root(arbre *tree,allseq *alldata);
double    Return_Lk_At_Root(arbre *tree);
void      Init_Tips_At_One_Site_Codon(char state1, char state2, char state3, double **p_lk, code *c_code, int ns);
#endif
