/*

nhPhyml :  a program that builds phylogenetic trees from DNA alignments using the non-homogeneous, non-stationary model of evolution conceived by Galtier and Gouy (1998) and the algorithmic structure of phyml (Guindon and Gascuel, 2003).

Copyright (C) Bastien Boussau. jul. 2005 onward

All parts of  the source except where indicated  are distributed under
the GNU public licence.  See http://www.opensource.org for details.

*/

#ifndef MODEL_H
#define MODEL_H

model *Init_Model(allseq *data, option *input);
int    PMat_Numeric(double l, model *mod, double **Pij, qmat *qmat_struct);
void   Update_Eigen(int dim, double *Q, double *U, double *V, double *Root);
void   Update_Qmat_Codon(model *mod, qmat *qmat_branch, double* cpi);
int    Matinv (double *x, int n, int m, double *space);
void   Update_Qmat_GG98(model *mod, double theta);
#endif
