/*

nhPhyml :  a program that builds phylogenetic trees from DNA alignments using the non-homogeneous, non-stationary model of evolution conceived by Galtier and Gouy (1998) and the algorithmic structure of phyml (Guindon and Gascuel, 2003).

Copyright (C) Bastien Boussau. jul. 2005 onward

All parts of  the source except where indicated  are distributed under
the GNU public licence.  See http://www.opensource.org for details.

*/

#ifndef OPTIMIZ_H
#define OPTIMIZ_H

void      Optimiz_Ext_Br(arbre *tree);
void      Round_Optimize(arbre *tree, allseq *data);
void      Round_Optimize_NoBL(arbre *tree, allseq *data);
void      Optimize_Param_Serie(node *a, node *d, edge *b_fcus, 
			  arbre *tree,allseq *alldata, int n_passes);
double    Br_Len_NR(arbre *tree,allseq *alldata, edge *b_fcus, int n_passes, double initl);
void      Optimiz_All_Free_Param_End(arbre *tree, int verbose);
double    Br_Theta_Golden_End(edge *b, double ax, double bx, double cx, double tol, 
			  double *xmin, arbre *tree, allseq *alldata);
void      Optimize_Theta_End(arbre *tree);
double    Br_Len_NR_End(arbre *tree,allseq *alldata, edge *b_fcus, int n_passes);
void      Optimize_Root(arbre *tree,allseq *alldata);
void      NR_Tot (arbre *tree);
double    NR_Omega (double *prop_omega, arbre *tree);
void      NR_Theta(double **prop_theta, arbre *tree);
double    NR_Theta_Br(edge *b_fcus, arbre *tree, int pos) ;
void      NR_Bl(double *prop_bl, arbre *tree);
double    NR_Bl_Br(edge *b_fcus, arbre *tree);
double    NR_Kappa (double *prop_kappa, arbre *tree) ;
double    NR_Alpha (double *prop_alpha, arbre *tree);
void      Optimiz_All_Free_Param_NR(arbre *tree);
void      NR_Tot_First (arbre *tree);
double    Br_Len_Theta_NR(arbre *tree,allseq *alldata, edge *b_fcus, int n_passes, double initl, double *inittheta);
double    Br_Len_Theta_NR_Slow(arbre *tree,allseq *alldata, edge *b_fcus, int n_passes, double initl, double *inittheta);
void Optimiz_All_Free_Param_But_Theta_Bl_NR(arbre *tree);
void Optimize_L_Coef(arbre *tree, int pos);
double L_Coef_Golden(double ax, double bx, double cx, double tol,
		     double *xmin, arbre *tree, allseq *alldata, double old, int pos);
int L_Coef_Brak(double *ax, double *bx, double *cx,
                double *fa, double *fb, double *fc,
                arbre *tree, int pos);
double Optimize_Branch_Thetas (arbre *tree, int n_step_max);
#endif
