/*

nhPhyml :  a program that builds phylogenetic trees from DNA alignments using the non-homogeneous, non-stationary model of evolution conceived by Galtier and Gouy (1998) and the algorithmic structure of phyml (Guindon and Gascuel, 2003).

Copyright (C) Bastien Boussau. jul. 2005 onward

All parts of  the source except where indicated  are distributed under
the GNU public licence.  See http://www.opensource.org for details.

*/


#ifndef CURR_H
#define CURR_H

void  Simu(arbre *tree, int n_step_max);
int   Mov_Backward_Topo_Bl(arbre *tree, double lk_old, edge **tested_b, int n_tested);
void  Unswap_N_Branch(arbre *tree, edge **b, int beg, int end);
void  Swap_N_Branch(arbre *tree,edge **b, int beg, int end);
void  Fix_All(arbre *tree);
void Select_Edges_To_Swap(arbre *tree, edge **sorted_b, int *n_neg);
void Update_Bl(arbre *tree, double fact);
void Make_N_Swap(arbre *tree,edge **b, int beg, int end);
#endif
